const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const work_order_operations = sequelize.define(
    'work_order_operations',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

operation_no: {
        type: DataTypes.INTEGER,
      
      

      },

operation_name: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"queued",


"ready",


"in_progress",


"paused",


"done",


"skipped"

        ],

      },

started_at: {
        type: DataTypes.DATE,
      
      

      },

ended_at: {
        type: DataTypes.DATE,
      
      

      },

good_quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

scrap_quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  work_order_operations.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity





































//end loop



    db.work_order_operations.belongsTo(db.work_orders, {
      as: 'work_order',
      foreignKey: {
        name: 'work_orderId',
      },
      constraints: false,
    });

    db.work_order_operations.belongsTo(db.work_centers, {
      as: 'work_center',
      foreignKey: {
        name: 'work_centerId',
      },
      constraints: false,
    });

    db.work_order_operations.belongsTo(db.machines, {
      as: 'machine',
      foreignKey: {
        name: 'machineId',
      },
      constraints: false,
    });

    db.work_order_operations.belongsTo(db.users, {
      as: 'performed_by',
      foreignKey: {
        name: 'performed_byId',
      },
      constraints: false,
    });




    db.work_order_operations.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.work_order_operations.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return work_order_operations;
};


